import pendulum
import sys

from src.sql.cruds.pschitt import PschittCrud
from src.sql.cruds.pschitt_user import PschittUserCrud
from src.sql.models.pschitt import PschittUserBase, PschittUserModel, PschittBase
from src.logs import Log
from src.settings import Settings

import pprint

log = Log("controllers_pschitt")
config = Settings().get_config()


class PschittUsers(object):
    def __init__(self):
        return

    @staticmethod
    def get_all():
        return PschittUserCrud.get_all_users()


class PschittUser(object):
    def __init__(self, user_id, guild_id):
        self.id = None
        self.user_id = user_id
        self.guild_id = guild_id
        self.pschitt = []
        return

    def get(self):
        if self.is_registered():
            pschitt_user = PschittUserBase(user_id=self.user_id, guild_id=self.guild_id)
            user = PschittUserCrud.get_user(pschitt_user)
            self.id = user.id
            self.user_id = user.user_id
            self.guild_id = user.guild_id
            self.pschitt = user.pschitt
        else:
            return PschittBase(user_id=self.user_id, guild_id=self.guild_id)

    def is_registered(self):
        pschitt_user = PschittUserBase(user_id=self.user_id, guild_id=self.guild_id)
        if PschittUserCrud.get_user(pschitt_user):
            return True
        else:
            log.error(f"This user ({self.user_id}) doesn't exist.")
            return False

    def register(self):
        pschitt_user = PschittUserBase(user_id=self.user_id, guild_id=self.guild_id)
        request = PschittUserCrud.create_user(pschitt_user)
        if request:
            log.info(f"User {self.user_id} registered")
            return True
        else:
            log.error(f"An error occured to register user {id}")
            return False

    def add_point(self):
        pschitt = PschittBase(pschitt_user_id=self.id)
        PschittCrud.create_pschitt(pschitt)
        self.get()
        return

    def delete(self):
        guild = guildBase(guild_id=self.guild_id, channel_id=self.channel_id)
        request = guildCrud.delete_guild(guild)
        if request["deleted"] > 0:
            log.info(f"Guild {self.guild_id} was correctly remove")
        else:
            log.error(f"An error occured on guild {self.guild_id} deletion")
        return
