from src.logs import Log
from src.settings import Settings
from src.sql.models.pschitt import PschittUserBase, PschittUserModel, PschittBase
from src.sql.schemas.pschitt import Pschitt, PschittUser
from src.sql.database import SessionLocalRo, SessionLocalRw
from sqlalchemy import desc, text

log = Log("crud_PschittUser")
config = Settings().get_config()


class PschittCrud:
    @staticmethod
    def create_pschitt(pschitt: PschittBase):
        pschitt_schema = Pschitt(pschitt_user_id=pschitt.pschitt_user_id)
        with SessionLocalRw() as session:
            session.add(pschitt_schema)
            session.commit()
        return True
